# Generated by Django 3.0.3 on 2020-03-08 14:27

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Batch',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('default_time_limit', models.IntegerField(help_text='Time limit for all inputs in the batch (in ms)')),
                ('default_memory_limit', models.IntegerField(help_text='Memory limit for all inputs in the batch (in MB)')),
            ],
        ),
        migrations.CreateModel(
            name='Competition',
            fields=[
                ('name', models.TextField(primary_key=True, serialize=False)),
                ('api_key', models.CharField(max_length=64)),
                ('webhook_url', models.URLField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Submit',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('priority', models.IntegerField(choices=[(0, 'Mega High'), (1, 'High'), (2, 'Normal'), (3, 'Low'), (4, 'Lowest')])),
                ('competition_specific_id', models.TextField()),
                ('asset_type', models.TextField()),
                ('submit_assets_url', models.FileField(upload_to='submit_assets/')),
            ],
        ),
        migrations.CreateModel(
            name='Task',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('test_assets_url', models.FileField(upload_to='task_assets/')),
                ('test_type', models.IntegerField(choices=[(0, 'Execute And Diff'), (1, 'Execute Custom')])),
                ('competition', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='judge.Competition')),
            ],
        ),
        migrations.CreateModel(
            name='SubmitTag',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('value', models.TextField()),
                ('submit', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='judge.Submit')),
            ],
        ),
        migrations.AddField(
            model_name='submit',
            name='task',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='judge.Task'),
        ),
        migrations.CreateModel(
            name='CompetitionPermission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('permission_level', models.IntegerField(choices=[(0, 'read-only'), (1, 'read-write')])),
                ('competition', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='judge.Competition')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.AddField(
            model_name='competition',
            name='users',
            field=models.ManyToManyField(through='judge.CompetitionPermission', to=settings.AUTH_USER_MODEL),
        ),
        migrations.CreateModel(
            name='BatchConfig',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('submit_asset_type', models.TextField()),
                ('time_limit', models.IntegerField(help_text='Time limit for all inputs in the batch (in ms)')),
                ('memory_limit', models.IntegerField(help_text='Memory limit for all inputs in the batch (in MB)')),
                ('batch', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='judge.Batch')),
            ],
        ),
        migrations.AddField(
            model_name='batch',
            name='task',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='judge.Task'),
        ),
        migrations.AddConstraint(
            model_name='task',
            constraint=models.UniqueConstraint(fields=('competition', 'name'), name='task_name_unique_in_competition'),
        ),
        migrations.AddConstraint(
            model_name='submittag',
            constraint=models.UniqueConstraint(fields=('submit', 'name'), name='single_value_per_submit_tag'),
        ),
        migrations.AddConstraint(
            model_name='competitionpermission',
            constraint=models.UniqueConstraint(fields=('competition', 'user'), name='one_permission_per_user_in_competition'),
        ),
        migrations.AddConstraint(
            model_name='batchconfig',
            constraint=models.UniqueConstraint(fields=('batch', 'submit_asset_type'), name='unique_asset_type_in_batch'),
        ),
        migrations.AddConstraint(
            model_name='batchconfig',
            constraint=models.CheckConstraint(check=models.Q(time_limit__gt=0), name='time_limit_above_zero'),
        ),
        migrations.AddConstraint(
            model_name='batchconfig',
            constraint=models.CheckConstraint(check=models.Q(memory_limit__gt=0), name='memory_limit_above_zero'),
        ),
        migrations.AddConstraint(
            model_name='batch',
            constraint=models.UniqueConstraint(fields=('task', 'name'), name='batch_name_unique_in_task'),
        ),
        migrations.AddConstraint(
            model_name='batch',
            constraint=models.CheckConstraint(check=models.Q(default_time_limit__gt=0), name='default_time_limit_above_zero'),
        ),
        migrations.AddConstraint(
            model_name='batch',
            constraint=models.CheckConstraint(check=models.Q(default_memory_limit__gt=0), name='default_memory_limit_above_zero'),
        ),
    ]
